﻿using System;
using System.Collections.Generic;
using UnityEngine;

public class CharaAppealData
{
	public bool IsCanApplel
	{
		get
		{
			return !this.IsAppealNow && !this.IsAppealCoolNow && this.m_GaugeValue >= 200;
		}
	}

	public GameObject AppealCutInpanel
	{
		get
		{
			return this.m_CutInPanel;
		}
		set
		{
			if (this.m_CutInPanel == value)
			{
				return;
			}
			this.m_CutInPanel = value;
			if (this.AppealCutInEffect)
			{
				this.AppealCutInEffect.transform.SetParent(this.m_CutInPanel.transform.parent, false);
			}
		}
	}

	public int CutInEffectOrder
	{
		get
		{
			return this.m_EffectOrder;
		}
		set
		{
			if (this.m_EffectOrder == value)
			{
				return;
			}
			this.m_EffectOrder = value;
			for (int i = 0; i < this.EffectRender.Count; i++)
			{
				this.EffectRender[i].sortingOrder = this.m_EffectRenderOrder[i] + this.m_EffectOrder;
			}
		}
	}

	public int GaugeCount
	{
		get
		{
			return this.AppealValue / 200;
		}
	}

	public int AppealGauge
	{
		get
		{
			return this.m_GaugeValue;
		}
		set
		{
			if (this.m_GaugeValue == value)
			{
				return;
			}
			this.m_GaugeValue = value;
			for (int i = 0; i < this.AllGaugeList.Count; i++)
			{
				this.AllGaugeList[i].fillAmount = (float)(this.m_GaugeValue - i * 200) / 200f;
				if (this.AllGaugeList[i].fillAmount <= 0f)
				{
					break;
				}
			}
		}
	}

	public int AppealValue;

	public int AppealMax;

	public bool IsAppealNow;

	public bool IsAppealCoolNow;

	private GameObject m_CutInPanel;

	private int m_EffectOrder;

	public List<ParticleSystem> AllCutInEffect = new List<ParticleSystem>();

	public List<ParticleSystemRenderer> EffectRender = new List<ParticleSystemRenderer>();

	public List<int> m_EffectRenderOrder = new List<int>();

	public UI2DSprite AppealCutIn;

	public UI2DSprite ReversalCutIn;

	public UIBasicSprite CoolTimeGauge;

	public UIBasicSprite AppelCoolFlash;

	public bool IsCutInNow;

	public bool IsRevarsalNow;

	public GameObject AppealGaugeEffect;

	public GameObject AppealCutInEffect;

	public GameObject ReversalCutInEffect;

	public Appeal_Mgr.CutInMove CutInType;

	public Transform GaugeGroup;

	public List<UISprite> AllGaugeList = new List<UISprite>();

	private int m_GaugeValue;

	public UIBasicSprite AppealFlashGauge;

	public AudioSource AudioSE;

	public string strPersonalVoice1;

	public string strPersonalVoice2;

	public string strJobVoice;

	public string strReversalVoice;

	public GameObject ReversalObj;

	public UIBasicSprite TimerGauge;

	public GameObject SweatEffect;

	public GameObject AuraEffect;

	public int AppealCombo;

	public AudioSourceMgr AudioVoice;

	public AudioSourceMgr ReversalVoice;
}
