﻿using System;
using UnityEngine;

public class CostumePartsEnabledMgr : BaseMgr<CostumePartsEnabledMgr>
{
	private void Start()
	{
		UIRoot componentInParent = base.GetComponentInParent<UIRoot>();
		this.m_goCostumePartsEnabledPanel = componentInParent.transform.Find("CostumePartsEnabledPanel").gameObject;
		if (this.m_goCostumePartsEnabledPanel == null)
		{
			Debug.LogError(string.Format("{0}が見つかりませんでした", "CostumePartsEnabledPanel"));
			return;
		}
		this.m_costumePartsEnabledCtrl = this.m_goCostumePartsEnabledPanel.GetComponent<CostumePartsEnabledCtrl>();
		this.m_goCostumePartsEnabledPanel.SetActive(false);
	}

	public void OnButtonClick()
	{
		string name = UIButton.current.name;
		this.m_costumePartsEnabledCtrl.OnButtonClick(name);
	}

	public void OnAllButtonClick()
	{
		this.m_costumePartsEnabledCtrl.OnAllButtonClick(true);
	}

	public void OnAllButtonCancelClick()
	{
		this.m_costumePartsEnabledCtrl.OnAllButtonClick(false);
	}

	public void OpenRandomPresetPanel()
	{
		this.m_costumePartsEnabledCtrl.Init(this.m_goCostumePartsEnabledPanel);
		this.m_costumePartsEnabledCtrl.LoadMaidPropData();
		this.m_goCostumePartsEnabledPanel.SetActive(true);
	}

	public void CloseRandomPresetPanel()
	{
		this.m_goCostumePartsEnabledPanel.SetActive(false);
	}

	private GameObject m_goCostumePartsEnabledPanel;

	private CostumePartsEnabledCtrl m_costumePartsEnabledCtrl;
}
