﻿using System;
using System.Collections.Generic;

public class DanceSelectManager : WfScreenManager
{
	public void Awake()
	{
		this.adv_kag_ = GameMain.Instance.ScriptMgr.adv_kag;
	}

	public override void Start()
	{
		base.Start();
		GameMain.Instance.MainLight.Reset();
		GameMain.Instance.CharacterMgr.ResetCharaPosAll();
		GameMain.Instance.MainCamera.Reset(CameraMain.CameraType.Target, true);
		GameMain.Instance.SoundMgr.VoiceStopAll();
		this.move_screen_ = base.children_dic["Move"].GetComponent<WfScreenMoveChildren>();
		string empty = string.Empty;
		string empty2 = string.Empty;
		if (this.adv_kag_.tag_backup != null && 0 < this.adv_kag_.tag_backup.Count && this.adv_kag_.tag_backup["name"] == "SceneDanceSelect")
		{
			NDebug.Assert(this.adv_kag_.tag_backup.ContainsKey("label"), "SceneDanceSelectにlabelの設定がされていませんでした");
			this.move_screen_.SetNextLabel(this.adv_kag_.tag_backup["label"]);
			DanceMain.RecetJumpLabel = this.move_screen_.next_label;
			if (this.adv_kag_.tag_backup.ContainsKey("cancel_label"))
			{
				DanceSelect component = base.children_dic["Main"].GetComponent<DanceSelect>();
				component.SetCancelLabel(this.adv_kag_.tag_backup["cancel_label"]);
			}
		}
		this.CallScreen("Main");
	}

	protected override void SettingChildrenList(Dictionary<string, WfScreenChildren> children_dic)
	{
		string[] array = new string[]
		{
			"Main",
			"Move"
		};
		for (int i = 0; i < array.Length; i++)
		{
			WfScreenChildren component = UTY.GetChildObject(base.gameObject, array[i], false).GetComponent<WfScreenChildren>();
			component.parent_mgr = this;
			children_dic.Add(array[i], component);
		}
	}

	public WfScreenMoveChildren move_screen
	{
		get
		{
			return this.move_screen_;
		}
	}

	private WfScreenMoveChildren move_screen_;

	private ADVKagManager adv_kag_;
}
