﻿using System;
using Schedule;

public class DescScheduleTraining : DescScheduleBase
{
	public override void Init(ScheduleTaskCtrl taskCtrl)
	{
		base.Init(taskCtrl);
		this.m_lReception = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Reception", true);
		this.m_lCare = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Care", true);
		this.m_lLovely = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Lovely", true);
		this.m_lElegance = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Elegance", true);
		this.m_lCharm = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Charm", true);
		this.m_lTeachRate = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "TeachRate", true);
		this.m_lMaidClassExp = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "MaidClassExp", true);
		this.m_lCooking = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Cooking", true);
		this.m_lVocal = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Vocal", true);
		this.m_lDance = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "Dance", true);
		this.m_lAppealPoint = new DescScheduleBase.ParamSet(this.m_goMaidParameterParent, "AP", true);
		this.m_listMaidItem.Add(this.m_lReception.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lCare.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lLovely.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lElegance.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lCharm.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lTeachRate.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lMaidClassExp.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lCooking.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lVocal.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lDance.GetVariableItem());
		this.m_listMaidItem.Add(this.m_lAppealPoint.GetVariableItem());
	}

	private void ResetPosition()
	{
		this.m_taskScrollView.ResetPosition();
	}

	protected override void UpdateView(ScheduleCSVData.ScheduleBase work_data)
	{
		this.UpdateCurentValue();
		this.UpdateAddValue(this.GetAddValue_Trainig());
		base.ExamineDisplayItem();
	}

	protected override void UpdateCurentValue()
	{
		Slot slot = this.taskCtrl.ScheduleMgr.GetScheduleApi().slot[this.taskCtrl.CurrentActiveSlotNo];
		Maid maid = slot.maid;
		if (maid == null)
		{
			return;
		}
		this.m_lReception.CurrentValueText = maid.status.reception.ToString();
		this.m_lCare.CurrentValueText = maid.status.care.ToString();
		this.m_lLovely.CurrentValueText = maid.status.lovely.ToString();
		this.m_lElegance.CurrentValueText = maid.status.elegance.ToString();
		this.m_lCharm.CurrentValueText = maid.status.charm.ToString();
		this.m_lTeachRate.CurrentValueText = (maid.status.teachRate / 10).ToString();
		this.m_lMaidClassExp.CurrentValueText = maid.status.selectedJobClass.cur_exp.ToString();
		this.m_lCooking.CurrentValueText = maid.status.cooking.ToString();
		this.m_lVocal.CurrentValueText = maid.status.vocal.ToString();
		this.m_lDance.CurrentValueText = maid.status.dance.ToString();
		this.m_lAppealPoint.CurrentValueText = maid.status.appealPoint.ToString();
	}

	protected override void UpdateAddValue(MaidParams maidParam)
	{
		this.m_lReception.AddValueText = base.Sign(maidParam.reception, null);
		this.m_lCare.AddValueText = base.Sign(maidParam.care, null);
		this.m_lLovely.AddValueText = base.Sign(maidParam.lovely, null);
		this.m_lElegance.AddValueText = base.Sign(maidParam.elegance, null);
		this.m_lCharm.AddValueText = base.Sign(maidParam.charm, null);
		this.m_lTeachRate.AddValueText = base.Sign(maidParam.teach_rate, null);
		this.m_lMaidClassExp.AddValueText = base.Sign(maidParam.exp, null);
		this.m_lCooking.AddValueText = base.Sign(maidParam.cooking, null);
		this.m_lVocal.AddValueText = base.Sign(maidParam.vocal, null);
		this.m_lDance.AddValueText = base.Sign(maidParam.dance, null);
		this.m_lAppealPoint.AddValueText = base.Sign(maidParam.Ap, null);
		Slot slot = this.taskCtrl.ScheduleMgr.GetScheduleApi().slot[this.taskCtrl.CurrentActiveSlotNo];
		Maid maid = slot.maid;
		if (maid == null)
		{
			return;
		}
		if (maid.status.selectedJobClass.next_exp == 0)
		{
			this.m_lMaidClassExp.AddValueText = base.Sign(0, null);
		}
	}

	private MaidParams GetAddValue_Trainig()
	{
		foreach (ScheduleBase scheduleBase in this.taskCtrl.GetWorksData(ScheduleTaskCtrl.TaskType.Training))
		{
			if (scheduleBase.workType == ScheduleType.Training)
			{
				ScheduleTraining scheduleTraining = (ScheduleTraining)scheduleBase;
				if (scheduleTraining.id == this.intTaskInd)
				{
					MaidParams simulateeMaidParams = scheduleTraining.simulateeMaidParams;
					SalonParams simulateeSalonMaidParams = scheduleTraining.simulateeSalonMaidParams;
					return simulateeMaidParams;
				}
			}
		}
		return null;
	}

	protected Slot m_currentSlotInfo;

	protected float m_contentPosY;

	protected UIScrollView m_taskScrollView;

	protected UIScrollBar m_taskScrollBar;

	protected DescScheduleBase.ParamSet m_lCare;

	protected DescScheduleBase.ParamSet m_lReception;

	protected DescScheduleBase.ParamSet m_lTeachRate;

	protected DescScheduleBase.ParamSet m_lLovely;

	protected DescScheduleBase.ParamSet m_lElegance;

	protected DescScheduleBase.ParamSet m_lCharm;

	protected DescScheduleBase.ParamSet m_lCooking;

	protected DescScheduleBase.ParamSet m_lVocal;

	protected DescScheduleBase.ParamSet m_lDance;

	protected DescScheduleBase.ParamSet m_lAppealPoint;

	protected DescScheduleBase.ParamSet m_lMaidClassExp;
}
