﻿using System;

namespace Leap.Unity
{
	public struct LeapDeviceInfo
	{
		public LeapDeviceInfo(LeapDeviceType initialization = LeapDeviceType.Invalid)
		{
			this.type = initialization;
			LeapDeviceType leapDeviceType = this.type;
			if (leapDeviceType != LeapDeviceType.Peripheral)
			{
				if (leapDeviceType != LeapDeviceType.Dragonfly)
				{
					this.isEmbedded = false;
					this.baseline = 0f;
					this.focalPlaneOffset = 0f;
					this.horizontalViewAngle = 0f;
					this.verticalViewAngle = 0f;
					this.trackingRange = 0f;
					this.serialID = string.Empty;
				}
				else
				{
					this.isEmbedded = false;
					this.baseline = 0.064f;
					this.focalPlaneOffset = 0.08f;
					this.horizontalViewAngle = 132.000015f;
					this.verticalViewAngle = 115.000023f;
					this.trackingRange = 0.47f;
					this.serialID = string.Empty;
				}
			}
			else
			{
				this.isEmbedded = false;
				this.baseline = 0.04f;
				this.focalPlaneOffset = 0.07f;
				this.horizontalViewAngle = 132.000015f;
				this.verticalViewAngle = 115.000023f;
				this.trackingRange = 0.47f;
				this.serialID = string.Empty;
			}
		}

		public LeapDeviceType type;

		public bool isEmbedded;

		public float baseline;

		public float focalPlaneOffset;

		public float horizontalViewAngle;

		public float verticalViewAngle;

		public float trackingRange;

		public string serialID;
	}
}
