﻿using System;
using System.Collections.Generic;

public class MaidManagement : WfScreenManager
{
	public static bool compatibilityMode
	{
		get
		{
			return DailyMgr.IsLegacy;
		}
	}

	public void Awake()
	{
		this.adv_kag_ = GameMain.Instance.ScriptMgr.adv_kag;
	}

	public override void Start()
	{
		base.Start();
		this.move_screen_ = base.children_dic["Move"].GetComponent<WfScreenMoveChildren>();
		string edit_label = string.Empty;
		string new_edit_label = string.Empty;
		string transfer_label = string.Empty;
		if (this.adv_kag_.tag_backup != null && 0 < this.adv_kag_.tag_backup.Count && this.adv_kag_.tag_backup["name"] == "SceneMaidManagement")
		{
			NDebug.Assert(this.adv_kag_.tag_backup.ContainsKey("label"), "SceneCallにlabelの設定がされていませんでした");
			if (this.adv_kag_.tag_backup.ContainsKey("type") && this.adv_kag_.tag_backup["type"] == "class_change")
			{
				NDebug.Assert("メイド管理の品評会モードは廃止になりました", false);
			}
			else
			{
				NDebug.Assert(this.adv_kag_.tag_backup.ContainsKey("edit_label"), "SceneCallにedit_labelの設定がされていませんでした");
				edit_label = this.adv_kag_.tag_backup["edit_label"];
				if (GameMain.Instance.CharacterMgr.status.isDaytime)
				{
					NDebug.Assert(this.adv_kag_.tag_backup.ContainsKey("new_edit_label"), "SceneCallにnew_edit_labelの設定がされていませんでした");
					new_edit_label = this.adv_kag_.tag_backup["new_edit_label"];
					NDebug.Assert(this.adv_kag_.tag_backup.ContainsKey("transfer_label"), "SceneCallにtransfer_labelの設定がされていませんでした");
					transfer_label = this.adv_kag_.tag_backup["transfer_label"];
				}
			}
			this.move_screen_.SetNextLabel(this.adv_kag_.tag_backup["label"]);
			if (!this.adv_kag_.tag_backup.ContainsKey("loop"))
			{
				MaidManagementMain.BackUpSelectMaidGUID = string.Empty;
			}
		}
		MaidManagementMain component = base.children_dic["Main"].GetComponent<MaidManagementMain>();
		component.SetMaidManagement(this, edit_label, new_edit_label, transfer_label);
		this.CallScreen("Main");
	}

	protected override void SettingChildrenList(Dictionary<string, WfScreenChildren> children_dic)
	{
		string[] array = new string[]
		{
			"Main",
			"Move"
		};
		for (int i = 0; i < array.Length; i++)
		{
			children_dic.Add(array[i], UTY.GetChildObject(base.gameObject, array[i], false).GetComponent<WfScreenChildren>());
		}
	}

	public WfScreenMoveChildren move_screen
	{
		get
		{
			return this.move_screen_;
		}
	}

	private WfScreenMoveChildren move_screen_;

	private ADVKagManager adv_kag_;
}
