﻿using System;
using System.Collections.Generic;
using UnityEngine;

public class MaidTouch : MonoBehaviour
{
	public static readonly string[] touchPointNameArray = new string[]
	{
		"通常",
		"唇",
		"胸",
		"クリトリス",
		"尻穴",
		"尻",
		string.Empty,
		"操作胸",
		"操作クリトリス"
	};

	public static readonly Vector3[] touchPointRotationArray = new Vector3[]
	{
		new Vector3(0f, 0f, 0f),
		new Vector3(0f, 0f, -90f),
		new Vector3(0f, 0f, -90f),
		new Vector3(90f, 0f, 0f),
		new Vector3(90f, 0f, 0f),
		new Vector3(0f, 0f, 0f)
	};

	public static readonly Vector3[] touchPointPostionArray = new Vector3[]
	{
		new Vector3(0f, 0f, 0f),
		new Vector3(0f, 0f, 0f),
		new Vector3(-0.04f, 0f, 0f),
		new Vector3(0f, 0f, 0f),
		new Vector3(0.075f, 0f, 0f),
		new Vector3(0f, 0f, 0f)
	};

	private OnaholeCharaManager owner;

	private GameObject colliderPrefab;

	private Dictionary<MaidTouch.POINT, MaidTouch.BoneData> boneDataDic = new Dictionary<MaidTouch.POINT, MaidTouch.BoneData>();

	private List<MaidTouch.TouchObject> touchObj = new List<MaidTouch.TouchObject>();

	private GameObject[] obj;

	private bool parentCheckEnd;

	public enum POINT
	{
		通常,
		唇,
		胸,
		クリトリス,
		尻穴,
		尻,
		発情,
		操作胸,
		操作クリトリス,
		MAX
	}

	public class BoneData
	{
		public Dictionary<string, GameObject> boneDic = new Dictionary<string, GameObject>();
	}

	public class TouchObject
	{
		public string pointName = string.Empty;

		public List<GameObject> obj = new List<GameObject>();

		public int mode;
	}
}
