﻿using System;
using I2.Loc;
using UnityEngine;

public static class Product
{
	public static Product.PAWCAQ FEA { get; private set; }

	public static bool AEWDA
	{
		get
		{
			return Product.FEA != Product.PAWCAQ.IKD && Product.FEA != Product.PAWCAQ.OQK;
		}
	}

	public static bool FDAWBW
	{
		get
		{
			return Product.FEA == Product.PAWCAQ.OQK || Product.FEA == Product.PAWCAQ.INA;
		}
	}

	public static bool QOPZX
	{
		get
		{
			return Product.FEA == Product.PAWCAQ.IKD || Product.FEA == Product.PAWCAQ.OQK;
		}
	}

	public static bool DOPLGBNE
	{
		get
		{
			return Product.FEA == Product.PAWCAQ.CMS || Product.FEA == Product.PAWCAQ.INA;
		}
	}

	public static Product.JQOVNMDS OUIWEHVA
	{
		get
		{
			if (!Product.AEWDA)
			{
				return Product.JQOVNMDS.P0L;
			}
			string currentLanguage = LocalizationManager.CurrentLanguage;
			return (!(currentLanguage == "English")) ? Product.JQOVNMDS.P0L : Product.JQOVNMDS.AQC;
		}
		set
		{
			if (!Product.AEWDA)
			{
				LocalizationManager.CurrentLanguage = Product.EnumConvert.FEWQAVASV(Product.JQOVNMDS.P0L);
				return;
			}
			LocalizationManager.CurrentLanguage = Product.EnumConvert.FEWQAVASV(value);
			foreach (LanguageSource languageSource in LocalizationManager.Sources)
			{
				languageSource.LoadAllLanguages(false);
			}
		}
	}

	public static Product.JQOVNMDS POEWBBA
	{
		get
		{
			return (!Product.AEWDA) ? Product.JQOVNMDS.P0L : Product.JQOVNMDS.AQC;
		}
	}

	public static string gameTitle
	{
		get
		{
			string term = "System/カスタムオーダーメイド3D 2";
			return LocalizationManager.GetTranslation(term, true, 0, true, false, null, Product.EnumConvert.FEWQAVASV(Product.OUIWEHVA));
		}
	}

	public static string windowTitel
	{
		get
		{
			string gameTitle = Product.gameTitle;
			return "CUSTOM ORDER MAID 3D 2";
		}
	}

	public static string gameDataPath
	{
		get
		{
			Product.PAWCAQ fea = Product.FEA;
			if (fea == Product.PAWCAQ.OQK)
			{
				return "_public";
			}
			if (fea == Product.PAWCAQ.CMS)
			{
				return "_en";
			}
			if (fea != Product.PAWCAQ.INA)
			{
				return string.Empty;
			}
			return "_enpublic";
		}
	}

	public static bool FD
	{
		get
		{
			return Product.FEA != Product.PAWCAQ.IKD;
		}
	}

	public static void Initialize(AFileSystemBase fileSystem)
	{
		Product.FEA = Product.PAWCAQ.IKD;
		Debug.Log("ProductType:" + Product.FEA.ToString());
		Product.OUIWEHVA = Product.POEWBBA;
	}

	public static void OnApplicationQuit()
	{
	}

	public enum PAWCAQ
	{
		IKD,
		OQK,
		CMS,
		INA
	}

	public enum JQOVNMDS
	{
		P0L,
		AQC
	}

	public static class EnumConvert
	{
		public static string GTREWVS(Product.JQOVNMDS p)
		{
			if (p == Product.JQOVNMDS.P0L)
			{
				return "日本語";
			}
			return "英語";
		}

		public static string FEWQAVASV(Product.JQOVNMDS p)
		{
			if (p == Product.JQOVNMDS.P0L)
			{
				return "Japanese";
			}
			if (p != Product.JQOVNMDS.AQC)
			{
				return "Japanese";
			}
			return "English";
		}

		public static string LAWEFV(Product.JQOVNMDS p)
		{
			return "System/言語/" + Product.EnumConvert.GTREWVS(p);
		}
	}
}
