﻿using System;

namespace Schedule
{
	public class ScheduleWork : ScheduleTraining
	{
		public ScheduleWork(ScheduleType workType, Slot slot, int workId) : base(workType, slot, workId)
		{
			this.workType = workType;
			this._slot = slot;
			this._id = workId;
			this.enabled = true;
			this.visible = true;
			if (this.legacyDisable)
			{
				this.visible = false;
			}
			if (ScheduleCSVData.WorkData.ContainsKey(workId))
			{
				ScheduleCSVData.Work work = ScheduleCSVData.WorkData[workId];
				if (!work.facility.isBusiness && work.workTyp != ScheduleCSVData.WorkType.PowerUp)
				{
					this.visible = false;
				}
				if (GameMain.Instance.CharacterMgr.status.lockNTRPlay && !work.facility.isEnableNTR)
				{
					this.visible = false;
				}
			}
		}
	}
}
