﻿using System;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.EventSystems;

public class VRVIPMenuElement : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler, IPointerClickHandler, IPointerDownHandler, IPointerUpHandler, IEventSystemHandler
{
	public void OnPointerEnter(PointerEventData eventData)
	{
		if (this.m_CallbackPointerEnter != null)
		{
			this.m_CallbackPointerEnter();
		}
	}

	public void OnPointerExit(PointerEventData eventData)
	{
		if (this.m_CallbackPointerExit != null)
		{
			this.m_CallbackPointerExit();
		}
	}

	public void OnPointerClick(PointerEventData eventData)
	{
		if (this.m_CallbackPointerClick != null)
		{
			this.m_CallbackPointerClick();
		}
	}

	public void OnPointerDown(PointerEventData eventData)
	{
		if (this.m_CallbackPointerDown != null)
		{
			this.m_CallbackPointerDown();
		}
	}

	public void OnPointerUp(PointerEventData eventData)
	{
		if (this.m_CallbackPointerUp != null)
		{
			this.m_CallbackPointerUp();
		}
	}

	public UnityAction m_CallbackPointerEnter;

	public UnityAction m_CallbackPointerExit;

	public UnityAction m_CallbackPointerClick;

	public UnityAction m_CallbackPointerDown;

	public UnityAction m_CallbackPointerUp;
}
