﻿using System;
using UnityEngine;

public abstract class WfFadeBehaviour : MonoBehaviour, InterfaceWfFade
{
	public virtual void OnStartedFadeIn()
	{
		UICamera.InputEnable = false;
	}

	public virtual void OnStartedFadeOut()
	{
		UICamera.InputEnable = false;
	}

	public abstract void OnUpdateFadeIn(float val);

	public abstract void OnUpdateFadeOut(float val);

	public virtual void OnCompleteFadeIn()
	{
		UICamera.InputEnable = true;
	}

	public virtual void OnCompleteFadeOut()
	{
		UICamera.InputEnable = true;
	}
}
