﻿using System;
using UnityEngine;

public class YotogiOldSkillUnitVR : MonoBehaviour
{
	public void Awake()
	{
		this.icon_ = UTY.GetChildObject(base.gameObject, "Parent/SkillIcon", false).GetComponent<YotogiOldSkillIcon>();
		this.name_label_ = UTY.GetChildObject(base.gameObject, "Parent/Text", false).GetComponent<UILabel>();
		this.btn_ = base.GetComponentInChildren<UIButton>();
		this.normal_sprite_name_ = this.btn_.normalSprite;
		this.hover_sprite_name_ = this.btn_.hoverSprite;
		this.box_collider_size_ = this.btn_.GetComponent<BoxCollider>().size;
	}

	public void SetSkillData(YotogiOld.VRSkillData set_skill_data)
	{
		this.skill_data_ = set_skill_data;
		this.name_label_.text = this.skill_data_.skill.name;
		this.icon_.SetSkillData(this.skill_data_.skill);
	}

	public bool isSelect
	{
		get
		{
			return this.btn_.normalSprite == this.hover_sprite_name_;
		}
		set
		{
			this.btn_.normalSprite = ((!value) ? this.normal_sprite_name_ : this.hover_sprite_name_);
		}
	}

	public YotogiOld.VRSkillData skill_data
	{
		get
		{
			return this.skill_data_;
		}
	}

	private YotogiOldSkillIcon icon_;

	private UILabel name_label_;

	private YotogiOld.VRSkillData skill_data_;

	private UIButton btn_;

	private string normal_sprite_name_;

	private string hover_sprite_name_;

	private Vector3 box_collider_size_;
}
